<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::read_write_mutex Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1read__write__mutex.html">read_write_mutex</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1read__write__mutex-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::read_write_mutex Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aaff5eb2cf7469f288c2f538b422da618"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1read__write__mutex.html#aaff5eb2cf7469f288c2f538b422da618">read_write_mutex</a> ()</td></tr>
<tr class="separator:aaff5eb2cf7469f288c2f538b422da618"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeee3d437fbe030273cefc14dc2d5f445"><td class="memItemLeft" align="right" valign="top"><a id="aeee3d437fbe030273cefc14dc2d5f445"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>read_write_mutex</b> (unsigned long max_locks_)</td></tr>
<tr class="separator:aeee3d437fbe030273cefc14dc2d5f445"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9075dbcae3c7f4add86ecbeebf6c70c"><td class="memItemLeft" align="right" valign="top"><a id="af9075dbcae3c7f4add86ecbeebf6c70c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>lock</b> () const</td></tr>
<tr class="separator:af9075dbcae3c7f4add86ecbeebf6c70c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a122b2b8e0126c87805ec5a01b971d87a"><td class="memItemLeft" align="right" valign="top"><a id="a122b2b8e0126c87805ec5a01b971d87a"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>unlock</b> () const</td></tr>
<tr class="separator:a122b2b8e0126c87805ec5a01b971d87a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6bb64f6503217218edfcd5705d4103f1"><td class="memItemLeft" align="right" valign="top"><a id="a6bb64f6503217218edfcd5705d4103f1"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>lock_readonly</b> () const</td></tr>
<tr class="separator:a6bb64f6503217218edfcd5705d4103f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae151c193659b9a71e534ad97e3c246cc"><td class="memItemLeft" align="right" valign="top"><a id="ae151c193659b9a71e534ad97e3c246cc"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>unlock_readonly</b> () const</td></tr>
<tr class="separator:ae151c193659b9a71e534ad97e3c246cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4e6e72e4b3c4645c3fae1283ce63319"><td class="memItemLeft" align="right" valign="top"><a id="ae4e6e72e4b3c4645c3fae1283ce63319"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>max_readonly_locks</b> () const</td></tr>
<tr class="separator:ae4e6e72e4b3c4645c3fae1283ce63319"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a8ff6bb4e0f4e5975422553650632a6fe"><td class="memItemLeft" align="right" valign="top"><a id="a8ff6bb4e0f4e5975422553650632a6fe"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>read_write_mutex</b> (<a class="el" href="classdlib_1_1read__write__mutex.html">read_write_mutex</a> &amp;)</td></tr>
<tr class="separator:a8ff6bb4e0f4e5975422553650632a6fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a764b5812e01e90d9be6cf32a10ace54f"><td class="memItemLeft" align="right" valign="top"><a id="a764b5812e01e90d9be6cf32a10ace54f"></a>
<a class="el" href="classdlib_1_1read__write__mutex.html">read_write_mutex</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1read__write__mutex.html">read_write_mutex</a> &amp;)</td></tr>
<tr class="separator:a764b5812e01e90d9be6cf32a10ace54f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a83289056a4baf8166fd0937ffa95708e"><td class="memItemLeft" align="right" valign="top"><a id="a83289056a4baf8166fd0937ffa95708e"></a>
<a class="el" href="classdlib_1_1mutex.html">mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m</b></td></tr>
<tr class="separator:a83289056a4baf8166fd0937ffa95708e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a960674c8605f14c8cbbbd3f28a69082c"><td class="memItemLeft" align="right" valign="top"><a id="a960674c8605f14c8cbbbd3f28a69082c"></a>
<a class="el" href="classdlib_1_1signaler.html">signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>s</b></td></tr>
<tr class="separator:a960674c8605f14c8cbbbd3f28a69082c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8623c01f501186ff6270901189ab561"><td class="memItemLeft" align="right" valign="top"><a id="ad8623c01f501186ff6270901189ab561"></a>
const unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>max_locks</b></td></tr>
<tr class="separator:ad8623c01f501186ff6270901189ab561"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa809043522e4646cdd438e11d94ab675"><td class="memItemLeft" align="right" valign="top"><a id="aa809043522e4646cdd438e11d94ab675"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>available_locks</b></td></tr>
<tr class="separator:aa809043522e4646cdd438e11d94ab675"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a982d38ef5982d13098f08cf23275fe74"><td class="memItemLeft" align="right" valign="top"><a id="a982d38ef5982d13098f08cf23275fe74"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>write_lock_in_progress</b></td></tr>
<tr class="separator:a982d38ef5982d13098f08cf23275fe74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7211ba11ee4a15526a49cc611d2e58d6"><td class="memItemLeft" align="right" valign="top"><a id="a7211ba11ee4a15526a49cc611d2e58d6"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>write_lock_active</b></td></tr>
<tr class="separator:a7211ba11ee4a15526a49cc611d2e58d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aaff5eb2cf7469f288c2f538b422da618"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaff5eb2cf7469f288c2f538b422da618">&#9670;&nbsp;</a></span>read_write_mutex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">dlib::read_write_mutex::read_write_mutex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">INITIAL VALUE
    - max_locks == defined by constructor 
    - available_locks == max_locks
    - write_lock_in_progress == false
    - write_lock_active == false

CONVENTION
    - Each time someone gets a read only lock they take one of the "available locks"
      and each write lock takes all possible locks (i.e. max_locks).  The number of
      available locks is recorded in available_locks.  Any time you try to lock this 
      object and there aren't available locks you have to wait.

    - max_locks == max_readonly_locks()

    - if (some thread is on the process of obtaining a write lock) then
        - write_lock_in_progress == true
    - else
        - write_lock_in_progress == false

    - if (some thread currently has a write lock on this mutex) then
        - write_lock_active == true
    - else
        - write_lock_active == false
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="read__write__mutex__extension_8h_source.html">read_write_mutex_extension.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
